#
#  -------------------------------------------------------------------------
#  MIT License
#  
#  Copyright (c) 2025 guyd789(Nord user forum) & Randy
#  
#  Permission is hereby granted, free of charge, to any person obtaining a copy
#  of this software and associated documentation files (the "Software"), to deal
#  in the Software without restriction, including without limitation the rights
#  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
#  copies of the Software, and to permit persons to whom the Software is
#  furnished to do so, subject to the following conditions:
#  
#  The above copyright notice and this permission notice shall be included in all
#  copies or substantial portions of the Software.
#  
#  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
#  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
#  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
#  SOFTWARE.
#  -------------------------------------------------------------------------
#
from tkinter import *
from tkinter import ttk  # needed for notebook

import ns4maps

# (Randy3) - Geometry
hC1   =  50 # height of Cell_1 
hC1b  =  25 # height of Cell_1b
hC2   =  50 # height of Cell_2
hC3   =  50 # height of Cell_3
hSS   =  25 # height of SubSection
wC1   = 150 # witdh of Cell_1
wSS0  =  35 # width of SubSection0 (for on/off)
wSS1  = 150 # width of SubSection1
wSS2  = 300 # width of SubSection2
wSS3  = 450 # width of SubSection2
wPad  =  10 # space between groups
hPad  =  10 # space between groups
wSection = 5*wC1+3*wPad # width of organ/piano/synth section

guinames = {}

# parameters not tied to layers
guinames['009-1'] = 'type'              #  'file type'
guinames['021-1'] = 'version'           #  'file version'
guinames['048-1'] = 'file version again'
guinames['013-6'] = 'bank'
guinames['015-3'] = 'location'          #  'location in bank'
guinames['025-1'] = 'checksum'
guinames['050-1'] = 'on/off'            #  'split'    
guinames['050-2'] = 'KB zone 1-2'       #  'KB zones 1-2 split point' off/on
guinames['050-3'] = 'KB zone 2-3'       #  'KB zones 2-3 split point'
guinames['050-4'] = 'KB zone 3-4'       #  'KB zones 3-4 split point'
guinames['050-5'] = '1-2'               #  'KB zones 1-2 split point'
guinames['051-1'] = '2-3'               #  'KB zones 2-3 split point'
guinames['051-5'] = '3-4'               #  'KB zones 3-4 split point'
guinames['052-1'] = '1-2 Xfade'         #  'KB zones 1-2 split point Xfade'
guinames['052-3'] = '2-3 Xfade'         #  'KB zones 2-3 split point Xfade'
guinames['052-5'] = '3-4 Xfade'         #  'KB zones 3-4 split point Xfade'
guinames['052-7'] = 'on/off'            #  'program transpose'
guinames['052-8'] = 'amount'            #  'program transpose amount'
guinames['054-8'] = 'global'            #  'FX comp global'
guinames['055-1'] = 'global'            #  'FX delay global'
guinames['055-2'] = 'global'            #  'FX reverb global'
guinames['114-5'] = 'preset'            #  'organ preset' 
guinames['084-5'] = 'organ'             #  'organ section'
guinames['084-6'] = 'piano'             #  'piano section'
guinames['084-7'] = 'synth'             #  'synth section'
guinames['084-8'] = 'organ'             #  'organ section (layer scene II)'
guinames['085-1'] = 'piano'             #  'piano section (layer scene II)'
guinames['085-2'] = 'synth'             #  'synth section (layer scene II)'
guinames['085-3'] = 'scene'             #  'which layer scene is active'
guinames['088-4'] = 'FX'
guinames['103-5'] = 'Pstick'            #  'organ pstick'
guinames['104-1'] = 'organ'             #  'organ rotary spkr'
guinames['105-5'] = 'drive'             #  'rotary spkr drive'
guinames['108-5'] = 'angle'             #  'rotary spkr stop position'
guinames['109-3'] = 'mode'              #  'rotary spkr stop'
guinames['109-4'] = 'slow/fast'         #  'rotary spkr slow/fast'
guinames['110-3'] = 'vib/chorus type'   #  'organ vib/chorus type'
guinames['401-6'] = 'synth arp group'

# organ parameters not tied to layers
guinames['175-1'] = 'Mod1 On/Off'       #  'FX mod 1'
guinames['175-2'] = 'MST CLK'           #  'FX mod 1 MST CLK'
guinames['175-3'] = 'Rate'              #  'FX mod 1 rate'
guinames['176-2'] = 'Wheel'             #  'FX mod 1 rate with wheel'
guinames['177-2'] = 'AT'                #  'FX mod 1 rate with A.T.'
guinames['178-2'] = 'Ctrlped'           #  'FX mod 1 rate with ctrlped'
guinames['179-2'] = 'Amount'            #  'FX mod 1 amount'
guinames['180-1'] = 'Wheel'             #  'FX mod 1 amount with wheel'
guinames['181-1'] = 'AT'                #  'FX mod 1 amount with A.T.'
guinames['182-1'] = 'Ctrlped'           #  'FX mod 1 amount with ctrlped'
guinames['183-1'] = 'Mode'              #  'FX mod 1 mode'
guinames['183-5'] = 'Mod2 On/Off'       #  'FX mod 2'
guinames['183-6'] = 'Rate'              #  'FX mod 2 rate'
guinames['184-5'] = 'Wheel'             #  'FX mod 2 rate with wheel'
guinames['185-5'] = 'AT'                #  'FX mod 2 rate with A.T.'
guinames['186-5'] = 'Ctrlped'           #  'FX mod 2 rate with ctrlped'
guinames['187-5'] = 'Amount'            #  'FX mod 2 amount'
guinames['188-4'] = 'Wheel'             #  'FX mod 2 amount with wheel'
guinames['189-4'] = 'AT'                #  'FX mod 2 amount with A.T.'
guinames['190-4'] = 'Ctrlped'           #  'FX mod 2 amount with ctrlped'
guinames['191-4'] = 'Mode'              #  'FX mod 2 mode'
guinames['191-8'] = 'Amp/EQ On/Off'     #  'FX amp sim/EQ'
guinames['192-1'] = 'TREBLE'            #  'FX amp sim/EQ treb'
guinames['192-8'] = 'MID'               #  'FX amp sim/EQ mid'
guinames['193-7'] = 'BASS'              #  'FX amp sim/EQ bass'
guinames['194-6'] = 'Mid freq'          #  'FX amp sim/EQ freq'
guinames['195-5'] = 'Wheel'             #  'FX amp sim/EQ freq with wheel'
guinames['196-5'] = 'AT'                #  'FX amp sim/EQ freq with A.T.'
guinames['197-5'] = 'Ctrlped'           #  'FX amp sim/EQ freq with ctrlped'
guinames['198-5'] = 'Drive'             #  'FX amp sim/EQ drive'
guinames['199-4'] = 'Wheel'             #  'FX amp sim/EQ drive with wheel'
guinames['200-4'] = 'AT'                #  'FX amp sim/EQ drive with A.T.'
guinames['201-4'] = 'Ctrlped'           #  'FX amp sim/EQ drive with ctrlped'
guinames['225-6'] = 'Amp/EQ mode'       #  'FX amp sim/EQ mode'
guinames['202-8'] = 'On/Off'            #  'FX comp'
guinames['203-1'] = 'Amount'            #  'FX comp amount'
guinames['203-8'] = 'Response'          #  'FX comp response'
guinames['204-1'] = 'On/Off'            #  'FX delay'
guinames['204-2'] = 'MST CLK'           #  'FX delay tempo MST CLK'
guinames['204-3'] = 'Tempo'             #  'FX delay tempo'
guinames['206-1'] = 'Wheel'             #  'FX delay tempo with wheel'
guinames['207-1'] = 'AT'                #  'FX delay tempo with A.T.'
guinames['208-1'] = 'Ctrlped'           #  'FX delay tempo with ctrlped'
guinames['211-6'] = 'Dry/Wet'           #  'FX delay mix'
guinames['212-5'] = 'Wheel'             #  'FX delay mix with wheel'
guinames['213-5'] = 'AT'                #  'FX delay mix with A.T.'
guinames['214-5'] = 'Ctrlped'           #  'FX delay mix with ctrlped'
guinames['215-5'] = 'Norm/Anal'         #  'FX delay normal/analog'
guinames['215-6'] = 'Ping-pong'         #  'FX delay ping pong'
guinames['215-7'] = 'Filter type'       #  'FX delay filter type'
guinames['216-1'] = 'Feedback'          #  'FX delay feedback'
guinames['216-8'] = 'Wheel'             #  'FX delay feedback with wheel'
guinames['217-8'] = 'AT'                #  'FX delay feedback with A.T.'
guinames['218-8'] = 'Ctrlped'           #  'FX delay feedback with ctrlped'
guinames['219-8'] = 'Effects'           #  'FX delay effects'
guinames['220-4'] = 'On/Off'            #  'FX reverb'
guinames['220-5'] = 'Amount'            #  'FX reverb amount' 
guinames['221-4'] = 'Wheel'             #  'FX reverb amount with wheel'
guinames['222-4'] = 'AT'                #  'FX reverb amount with A.T.'
guinames['223-4'] = 'Ctrlped'           #  'FX reverb amount with ctrlped'
guinames['224-4'] = 'Dark/bright'       #  'FX reverb dark/bright'
guinames['224-6'] = 'Reverb type'       #  'FX reverb type

# organ parameters with 2 layers
guinames['095-3'] = 'Main'              #  'layer'
guinames['095-6'] = 'Scene II'          #  'layer (scene II)'
guinames['095-7'] = 'volume'
guinames['096-6'] = 'Wheel'             #  'volume change with wheel'
guinames['097-6'] = 'AT'                #  'volume change with A.T.'
guinames['098-6'] = 'Ctrlped'           #  'volume change with ctrlped'
guinames['113-1'] = 'KB zones'
guinames['113-5'] = 'Octave shift'
guinames['114-1'] = 'Susped'            #  'organ susped'
guinames['114-2'] = 'organ model'
guinames['117-1'] = 'drawbar 1'
guinames['117-5'] = 'Wheel1'            #  'drawbar 1 with wheel'
guinames['118-2'] = 'AT1'               #  'drawbar 1 with A.T.'
guinames['118-7'] = 'Ctrlped1'          #  'drawbar 1 with ctrlped'
guinames['119-4'] = 'drawbar 2'
guinames['119-8'] = 'Wheel2'            #  'drawbar 2 with wheel'
guinames['120-5'] = 'AT2'               #  'drawbar 2 with A.T.'
guinames['121-2'] = 'Ctrlped2'          #  'drawbar 2 with ctrlped'
guinames['121-7'] = 'drawbar 3'
guinames['122-3'] = 'Wheel3'            #  'drawbar 3 with wheel'
guinames['122-8'] = 'AT3'               #  'drawbar 3 with A.T.'
guinames['123-5'] = 'Ctrlped3'          #  'drawbar 3 with ctrlped'
guinames['124-2'] = 'drawbar 4'
guinames['124-6'] = 'Wheel4'            #  'drawbar 4 with wheel'
guinames['125-3'] = 'AT4'               #  'drawbar 4 with A.T.'
guinames['125-8'] = 'Ctrlped4'          #  'drawbar 4 with ctrlped'
guinames['126-5'] = 'drawbar 5'
guinames['127-1'] = 'Wheel5'            #  'drawbar 5 with wheel'
guinames['127-6'] = 'AT5'               #  'drawbar 5 with A.T.'
guinames['128-3'] = 'Ctrlped5'          #  'drawbar 5 with ctrlped'
guinames['128-8'] = 'drawbar 6'
guinames['129-4'] = 'Wheel6'            #  'drawbar 6 with wheel'
guinames['130-1'] = 'AT6'               #  'drawbar 6 with A.T.'
guinames['130-6'] = 'Ctrlped6'          #  'drawbar 6 with ctrlped'
guinames['131-3'] = 'drawbar 7'
guinames['131-7'] = 'Wheel7'            #  'drawbar 7 with wheel'
guinames['132-4'] = 'AT7'               #  'drawbar 7 with A.T.'
guinames['133-1'] = 'Ctrlped7'          #  'drawbar 7 with ctrlped'
guinames['133-6'] = 'drawbar 8'
guinames['134-2'] = 'Wheel8'            #  'drawbar 8 with wheel'
guinames['134-7'] = 'AT8'               #  'drawbar 8 with A.T.'
guinames['135-4'] = 'Ctrlped8'          #  'drawbar 8 with ctrlped'
guinames['136-1'] = 'drawbar 9'
guinames['136-5'] = 'Wheel9'            #  'drawbar 9 with wheel'
guinames['137-2'] = 'AT9'               #  'drawbar 9 with A.T.'
guinames['137-7'] = 'Ctrlped9'          #  'drawbar 9 with ctrlped'
guinames['141-1'] = 'vib/chorus'
guinames['141-2'] = 'percussion'
guinames['141-3'] = 'harm 3rd'          #  'perc harm 3rd'
guinames['141-4'] = 'decay fast'        #  'perc decay fast'
guinames['141-5'] = 'vol soft'          #  'perc vol soft'

# piano parameters with 2 layers
guinames['230-3'] = 'Main'              #  'Layer'
guinames['230-6'] = 'Scene II'          #  'Layer(sceneII)'
guinames['230-7'] = 'Volume'
guinames['231-6'] = 'Wheel'             #  'Volume change with wheel'
guinames['232-6'] = 'AT'                #  'Volume change with A.T.'
guinames['233-6'] = 'Ctrlped'           #  'Volume change with ctrlped'
guinames['243-1'] = 'KB zones'
guinames['243-5'] = 'Octave shift'
guinames['244-1'] = 'Pstick'
guinames['244-2'] = 'Sustpedal'
guinames['244-3'] = 'Piano type'
guinames['244-6'] = 'Piano model slot'  # not used
guinames['245-3'] = 'Piano model variation' # not used - value concatened with piano name
guinames['245-5'] = 'Piano name'        #  'Piano model ID/name'
guinames['249-5'] = 'Soft rel'
guinames['249-6'] = 'Strg res'          #  'String res'
guinames['249-7'] = 'Pedal n.'          #  'Pedal noise'
guinames['249-8'] = 'Touch'
guinames['250-2'] = 'Unison level'
guinames['250-4'] = 'Dyn comp'
guinames['250-7'] = 'Timbre'
guinames['267-1'] = 'Mod1 On/Off'       #  'FX mod 1'
guinames['267-2'] = 'MST CLK'           #  'FX mod 1 MST CLK'
guinames['267-3'] = 'Rate'              #  'FX mod 1 rate'
guinames['268-2'] = 'Wheel'             #  'FX mod 1 rate with wheel'
guinames['269-2'] = 'AT'                #  'FX mod 1 rate with A.T.'
guinames['270-2'] = 'Ctrlped'           #  'FX mod 1 rate with ctrlped'
guinames['271-2'] = 'Amount'            #  'FX mod 1 amount'
guinames['272-1'] = 'Wheel'             #  'FX mod 1 amount with wheel'
guinames['273-1'] = 'AT'                #  'FX mod 1 amount with A.T.'
guinames['274-1'] = 'Ctrlped'           #  'FX mod 1 amount with ctrlped'
guinames['275-1'] = 'Mode'              #  'FX mod 1 mode'
guinames['275-5'] = 'Mod2 On/Off'       #  'FX mod 2'
guinames['275-6'] = 'Rate'              #  'FX mod 2 rate'
guinames['276-5'] = 'Wheel'             #  'FX mod 2 rate with wheel'
guinames['277-5'] = 'AT'                #  'FX mod 2 rate with A.T.'
guinames['278-5'] = 'Ctrlped'           #  'FX mod 2 rate with ctrlped'
guinames['279-5'] = 'Amount'            #  'FX mod 2 amount'
guinames['280-4'] = 'Wheel'             #  'FX mod 2 amount with wheel'
guinames['281-4'] = 'AT'                #  'FX mod 2 amount with A.T.'
guinames['282-4'] = 'Ctrlped'           #  'FX mod 2 amount with ctrlped'
guinames['283-4'] = 'Mode'              #  'FX mod 2 mode'
guinames['283-8'] = 'Amp/EQ On/Off'     #  'FX amp sim/EQ'
guinames['284-1'] = 'TREBLE'            #  'FX amp sim/EQ treb'
guinames['284-8'] = 'MID'               #  'FX amp sim/EQ mid'
guinames['285-7'] = 'BASS'              #  'FX amp sim/EQ bass'
guinames['286-6'] = 'Mid freq'          #  'FX amp sim/EQ freq'
guinames['287-5'] = 'Wheel'             #  'FX amp sim/EQ freq with wheel'
guinames['288-5'] = 'AT'                #  'FX amp sim/EQ freq with A.T.'
guinames['289-5'] = 'Ctrlped'           #  'FX amp sim/EQ freq with ctrlped'
guinames['290-5'] = 'Drive'             #  'FX amp sim/EQ drive'
guinames['291-4'] = 'Wheel'             #  'FX amp sim/EQ drive with wheel'
guinames['292-4'] = 'AT'                #  'FX amp sim/EQ drive with A.T.'
guinames['293-4'] = 'Ctrlped'           #  'FX amp sim/EQ drive with ctrlped'
guinames['317-6'] = 'Amp/EQ mode'       #  'FX amp sim/EQ mode'
guinames['294-8'] = 'On/Off'            #  'FX comp'
guinames['295-1'] = 'Amount'            #  'FX comp amount'
guinames['295-8'] = 'Response'          #  'FX comp response'
guinames['296-1'] = 'On/Off'            #  'FX delay'
guinames['296-2'] = 'MST CLK'           #  'FX delay tempo MST CLK'
guinames['296-3'] = 'Tempo'             #  'FX delay tempo'
guinames['298-1'] = 'Wheel'             #  'FX delay tempo with wheel'
guinames['299-1'] = 'AT'                #  'FX delay tempo with A.T.'
guinames['300-1'] = 'Ctrlped'           #  'FX delay tempo with ctrlped'
guinames['303-6'] = 'Dry/Wet'           #  'FX delay mix'
guinames['304-5'] = 'Wheel'             #  'FX delay mix with wheel'
guinames['305-5'] = 'AT'                #  'FX delay mix with A.T.'
guinames['306-5'] = 'Ctrlped'           #  'FX delay mix with ctrlped'
guinames['307-5'] = 'Norm/Anal'         #  'FX delay normal/analog'
guinames['307-6'] = 'Ping-pong'         #  'FX delay ping pong'
guinames['307-7'] = 'Filter type'       #  'FX delay filter type'
guinames['308-1'] = 'Feedback'          #  'FX delay feedback'
guinames['308-8'] = 'Wheel'             #  'FX delay feedback with wheel'
guinames['309-8'] = 'AT'                #  'FX delay feedback with A.T.'
guinames['310-8'] = 'Ctrlped'           #  'FX delay feedback with ctrlped'
guinames['311-8'] = 'Effects'           #  'FX delay effects'
guinames['312-4'] = 'On/Off'            #  'FX reverb'
guinames['312-5'] = 'Amount'            #  'FX reverb amount' 
guinames['313-4'] = 'Wheel'             #  'FX reverb amount with wheel'
guinames['314-4'] = 'AT'                #  'FX reverb amount with A.T.'
guinames['315-4'] = 'Ctrlped'           #  'FX reverb amount with ctrlped'
guinames['316-4'] = 'Dark/bright'       #  'FX reverb dark/bright'
guinames['316-6'] = 'Reverb type'       #  'FX reverb type'

# synth parameters with 3 layers
guinames['377-5'] = 'Main'              # 'layer'
guinames['378-2'] = 'Scene II'          # 'layer (scene II)'
guinames['378-3'] = 'Volume'
guinames['379-2'] = 'Wheel'             # 'volume change with wheel'
guinames['380-2'] = 'AT'                # 'volume change with A.T.'
guinames['381-2'] = 'Ctrlped'           # 'volume change with ctrlped'
guinames['389-8'] = 'Pan'               
guinames['408-1'] = 'Samples/Analog'    # 'samples/analog'
guinames['408-7'] = 'Category'          # 'sample slot'
guinames['410-3'] = 'Name'              # 'sample ID/name'
guinames['575-6'] = 'Options'           # 'sample options'
guinames['604-3'] = 'Bright'            # 'sample bright'
guinames['414-3'] = 'KB zones'
guinames['414-7'] = 'Octave shift'
guinames['415-3'] = 'Pstick'
guinames['415-4'] = 'Pstick rng'
guinames['415-8'] = 'Sustped'
guinames['416-1'] = 'Mode'              # 'vibrato mode'
guinames['453-5'] = 'Delay'             # 'vibrato delay'
guinames['602-6'] = 'Rate'              # 'vibrato rate'
guinames['603-5'] = 'Amount'            # 'vibrato amount'
guinames['416-7'] = 'Mono'
guinames['416-6'] = 'Legato'
guinames['416-8'] = 'Priority'          # 'voice priority'      
guinames['417-2'] = 'Glide'
guinames['401-8'] = 'KB hold'           #  'synth arp KB hold on/off' 
guinames['423-7'] = 'Excl/Incl'         #  'arp KB hold' 
guinames['423-8'] = 'Arp run'           #  'arpeggiator run'
guinames['424-1'] = 'Mode'              #  'arpeggiator mode'
guinames['424-3'] = 'Pattern'           #  'arp pattern'
guinames['424-4'] = 'KB sync'           #  'KB sync on/off'
guinames['424-5'] = 'Range/env'         #  'arp range/env'
guinames['425-4'] = 'Wheel'             #  'arp range/env with wheel'
guinames['426-4'] = 'AT'                #  'arp range/env with A.T.'
guinames['427-4'] = 'Ctrlped'           #  'arp range/env with ctrlped'
guinames['428-4'] = 'Direction'         #  'arp direction'
guinames['428-6'] = 'Zigzag'            #  'arp zigzag'
guinames['428-7'] = 'MST CLK'           #  'arp MST CLK'
guinames['428-8'] = 'Rate/time'         #  'arp rate/time'
guinames['429-7'] = 'Wheel'             #  'arp rate/time with wheel'
guinames['430-7'] = 'AT'                #  'arp rate/time with A.T.'
guinames['431-7'] = 'Ctrlped'           #  'arp rate/time with ctrlped'
guinames['432-7'] = 'Pattern length'    #  'arp pattern length'
guinames['433-3'] = 'Accent'            #  'arpeggiator accent'
guinames['437-3'] = 'Gate'              #  'arpeggiator gate'
guinames['441-3'] = 'Pan'               #  'arpeggiator pan'
guinames['445-3'] = 'Level'             #  'unison level'
guinames['418-1'] = 'Extern'
guinames['421-8'] = 'Program'           #  'extern program'
guinames['445-5'] = 'CC val1'           #  'extern CC VAL1'
guinames['446-4'] = 'Wheel'             #  'extern CC VAL1 with wheel'
guinames['447-4'] = 'AT'                #  'extern CC VAL1 with A.T.'
guinames['448-4'] = 'Ctrlped'           #  'extern CC VAL1 with ctrlped'
guinames['449-4'] = 'CC val2'           #  'extern CC VAL2'
guinames['450-3'] = 'Wheel'             #  'extern CC VAL2 with wheel'
guinames['451-3'] = 'AT'                #  'extern CC VAL2 with A.T.'
guinames['452-3'] = 'Ctrlped'           #  'extern CC VAL2 with ctrlped'
guinames['561-3'] = 'Type'              #  'analog type (knob 1)'
guinames['561-8'] = 'Cat'               #  'analog cat (knob 2)'
guinames['562-4'] = 'Wave/partial'      #  'analog wave/partial (knob 3)'
guinames['563-2'] = 'Osc Ctrl'
guinames['564-1'] = 'Wheel'             #  'osc ctrl with wheel'
guinames['565-1'] = 'AT'                #  'osc ctrl with A.T.'
guinames['566-1'] = 'Ctrlped'           #  'osc ctrl with ctrlped'
guinames['567-1'] = 'pitch fine'
guinames['567-8'] = 'pitch coarse'
guinames['568-8'] = 'Attack'            #  'osc env attack'
guinames['569-7'] = 'Decay'             #  'osc env decay'
guinames['570-6'] = 'Release'           #  'osc env release'
guinames['571-5'] = 'Env amt'           #  'osc env amt'
guinames['572-4'] = 'Wheel'             #  'osc env amt with wheel'
guinames['573-4'] = 'AT'                #  'osc env amt with A.T.'
guinames['574-4'] = 'Ctrlped'           #  'osc env amt with ctrlped'
guinames['575-4'] = 'Env-to-pitch'      #  'osc env-to-pitch'
guinames['575-5'] = 'Env veloc.'        #  'osc env velocity'
guinames['575-8'] = 'Target'            #  'LFO target'
guinames['576-2'] = 'Shape'             #  'LFO shape'
guinames['576-5'] = 'LFO mst clk'
guinames['576-6'] = 'Rate/time'         #  'LFO rate/time'
guinames['577-5'] = 'Wheel'             #  'LFO rate/time with wheel' 
guinames['578-5'] = 'AT'                #  'LFO rate/time with A.T.'
guinames['579-5'] = 'Ctrlped'           #  'LFO rate/time with ctrlped'
guinames['580-5'] = 'Mod amt'           #  'LFO mod amt'
guinames['581-4'] = 'Wheel'             #  'LFO mod amt with wheel'
guinames['582-4'] = 'AT'                #  'LFO mod amt with A.T.'
guinames['583-4'] = 'Ctrlped'           #  'LFO mod amt with ctrlped'
guinames['584-4'] = 'Attack'            #  'amp env attack'
guinames['585-3'] = 'Decay'             #  'amp env decay'
guinames['586-2'] = 'Release'           #  'amp env release'
guinames['587-1'] = 'Velocity'          #  'amp env velocity'
guinames['602-5'] = 'filter on/off'     #  'filter'
guinames['587-3'] = 'Type'              #  'filter type'
guinames['587-6'] = 'Freq'              #  'filter freq'
guinames['588-5'] = 'Wheel'             #  'filter freq with wheel'
guinames['589-5'] = 'AT'                #  'filter freq with A.T.'
guinames['590-5'] = 'Ctrlped'           #  'filter freq with ctrlped'
guinames['591-5'] = 'Res/Freq HP'       #  'filter resonance / freq HP'
guinames['592-4'] = 'Wheel'             #  'filter res with wheel'
guinames['593-4'] = 'AT'                #  'filter res with A.T.'
guinames['594-4'] = 'Ctrlped'           #  'filter res with ctrlped'
guinames['595-4'] = 'Kbd Trk'           #  'filter track'
guinames['595-6'] = 'Drive'             #  'filter drive'
guinames['595-8'] = 'Env amt'           #  'filter env amt'
guinames['596-7'] = 'Wheel'             #  'filter env amt with wheel'
guinames['597-7'] = 'AT'                #  'filter env amt with A.T.'
guinames['598-7'] = 'Ctrlped'           #  'filter env amt with ctrlped'
guinames['599-7'] = 'Attack'            #  'filter env attack'
guinames['600-6'] = 'Decay'             #  'filter env decay'
guinames['601-5'] = 'Release'           #  'filter env release'
guinames['602-4'] = 'Velocity'          #  'filter velocity'
guinames['705-1'] = 'Mod1 On/Off'       #  'FX mod 1'
guinames['705-2'] = 'MST CLK'           #  'FX mod 1 MST CLK'
guinames['705-3'] = 'Rate'              #  'FX mod 1 rate'
guinames['706-2'] = 'Wheel'             #  'FX mod 1 rate with wheel'
guinames['707-2'] = 'AT'                #  'FX mod 1 rate with A.T.'
guinames['708-2'] = 'Ctrlped'           #  'FX mod 1 rate with ctrlped'
guinames['709-2'] = 'Amount'            #  'FX mod 1 amount'
guinames['710-1'] = 'Wheel'             #  'FX mod 1 amount with wheel'
guinames['711-1'] = 'AT'                #  'FX mod 1 amount with A.T.'
guinames['712-1'] = 'Ctrlped'           #  'FX mod 1 amount with ctrlped'
guinames['713-1'] = 'Mode'              #  'FX mod 1 mode'
guinames['713-5'] = 'Mod2 On/Off'       #  'FX mod 2'
guinames['713-6'] = 'Rate'              #  'FX mod 2 rate'
guinames['714-5'] = 'Wheel'             #  'FX mod 2 rate with wheel'
guinames['715-5'] = 'AT'                #  'FX mod 2 rate with A.T.'
guinames['716-5'] = 'Ctrlped'           #  'FX mod 2 rate with ctrlped'
guinames['717-5'] = 'Amount'            #  'FX mod 2 amount'
guinames['718-4'] = 'Wheel'             #  'FX mod 2 amount with wheel'
guinames['719-4'] = 'AT'                #  'FX mod 2 amount with A.T.'
guinames['720-4'] = 'Ctrlped'           #  'FX mod 2 amount with ctrlped'
guinames['721-4'] = 'Mode'              #  'FX mod 2 mode'
guinames['721-8'] = 'Amp/EQ On/Off'     #  'FX amp sim/EQ'
guinames['722-1'] = 'TREBLE'            #  'FX amp sim/EQ treb'
guinames['722-8'] = 'MID'               #  'FX amp sim/EQ mid'
guinames['723-7'] = 'BASS'              #  'FX amp sim/EQ bass'
guinames['724-6'] = 'Mid freq'          #  'FX amp sim/EQ freq'
guinames['725-5'] = 'Wheel'             #  'FX amp sim/EQ freq with wheel'
guinames['726-5'] = 'AT'                #  'FX amp sim/EQ freq with A.T.'
guinames['727-5'] = 'Ctrlped'           #  'FX amp sim/EQ freq with ctrlped'
guinames['728-5'] = 'Drive'             #  'FX amp sim/EQ drive'
guinames['729-4'] = 'Wheel'             #  'FX amp sim/EQ drive with wheel'
guinames['730-4'] = 'AT'                #  'FX amp sim/EQ drive with A.T.'
guinames['731-4'] = 'Ctrlped'           #  'FX amp sim/EQ drive with ctrlped'
guinames['755-6'] = 'Amp/EQ mode'       #  'FX amp sim/EQ mode'
guinames['732-8'] = 'On/Off'            #  'FX comp'
guinames['733-1'] = 'Amount'            #  'FX comp amount'
guinames['733-8'] = 'Response'          #  'FX comp response'
guinames['734-1'] = 'On/Off'            #  'FX delay'
guinames['734-2'] = 'MST CLK'           #  'FX delay tempo MST CLK'
guinames['734-3'] = 'Tempo'             #  'FX delay tempo'
guinames['736-1'] = 'Wheel'             #  'FX delay tempo with wheel'
guinames['737-1'] = 'AT'                #  'FX delay tempo with A.T.'
guinames['738-1'] = 'Ctrlped'           #  'FX delay tempo with ctrlped'
guinames['741-6'] = 'Dry/Wet'           #  'FX delay mix'
guinames['742-5'] = 'Wheel'             #  'FX delay mix with wheel'
guinames['743-5'] = 'AT'                #  'FX delay mix with A.T.'
guinames['744-5'] = 'Ctrlped'           #  'FX delay mix with ctrlped'
guinames['745-5'] = 'Norm/Anal'         #  'FX delay normal/analog'
guinames['745-6'] = 'Ping-pong'         #  'FX delay ping pong'
guinames['745-7'] = 'Filter type'       #  'FX delay filter type'
guinames['746-1'] = 'Feedback'          #  'FX delay feedback'
guinames['746-8'] = 'Wheel'             #  'FX delay feedback with wheel'
guinames['747-8'] = 'AT'                #  'FX delay feedback with A.T.'
guinames['748-8'] = 'Ctrlped'           #  'FX delay feedback with ctrlped'
guinames['749-8'] = 'Effects'           #  'FX delay effects'
guinames['750-4'] = 'On/Off'            #  'FX reverb'
guinames['750-5'] = 'Amount'            #  'FX reverb amount' 
guinames['751-4'] = 'Wheel'             #  'FX reverb amount with wheel'
guinames['752-4'] = 'AT'                #  'FX reverb amount with A.T.'
guinames['753-4'] = 'Ctrlped'           #  'FX reverb amount with ctrlped'
guinames['754-4'] = 'Dark/bright'       #  'FX reverb dark/bright'
guinames['754-6'] = 'Reverb type'       #  'FX reverb type'


paramdata = {}  # (Randy2) made paramdata global

# ================================================================
#  writes data from the input file to a single output file for testing
#
def writeData( inputFilename, groupparams, filename ):  # (Randy2) made paramdata global

    print( 'Writing', filename )
    fid = open( filename, 'w' )
    fid.write( 'Data from ' + inputFilename + '\n' )
    fid.write( '\n' )

    for group in ns4maps.groups:
        for paramID in groupparams[group]:

            numlayers = paramdata[paramID]['numlayers']
    
            fid.write( 'parameter ' + paramID +  '    ' + paramdata[paramID]['name'] + '\n' )
            fid.write( '    group ' + paramdata[paramID]['group'] + '\n' )
            fid.write( '    numlayers ' + str(numlayers) + '\n' )
    
            fid.write( '    raw values:\n' )
            for n in range(numlayers):
                fid.write( '        ' + str(paramdata[paramID][n]['rawval']) + '\n' )
    
            fid.write( '    interpreted values:\n' )
            for n in range(numlayers):
                fid.write( '        ' + paramdata[paramID][n]['outval'] + '\n' )

    fid.write( '\n' )
    fid.close()
    print( 'Closed ', filename )

# ================================================================
#  writes list of parameter IDs and names, ordered like in the csv output files
#
def writeIDs( groupparams, filename ):  # (Randy2) made paramdata global

    print( 'Writing', filename )
    fid = open( filename, 'w' )

    for group in ns4maps.groups:
        fid.write( "# parameters for group " + group + "\n" )
        for paramID in groupparams[group]:

            fid.write( "csvnames['" + paramID + "'] = '" + paramdata[paramID]['name'] + "'\n" )
    fid.close()
    print( 'Closed ', filename )

# ================================================================
#  paramdata is a python "dictionary" indexed by the parameter ID number (paramID).
#
#  paramID is a string of the form XXX-Y
#
#  The dictionary has these fields:
#
#       paramdata[paramID]['name'] = string
#       paramdata[paramID]['group'] = 'm', 'o', 'p', or 's'
#               'm' = master (all parameters not tied to individual layers, 
#                             including some organ parameters)
#               'o' = organ (2 layers)
#               'p' = piano (2 layers)
#               's' = synth (3 layers)
#       paramdata[paramID]['numlayers'] = number of layers
#       paramdata[paramID][layer index]['rawval'] = raw (not interpreted) integer value
#       paramdata[paramID][layer index]['outval'] = interpreted value (a string)
#
#  groupparams is a dictionary whose keys are 'm', 'o', 'p', and 's'.
#  Each of those is a list of id-strings.
#  This is used to specify the ordering of the parameters in the output.
#

def inferGroupFX( paramID ):           # determine the group of paramID
    bitloc = ns4maps.getLocFromStr( paramID )
    if bitloc < ns4maps.getLocFromStr( '267-1' ):
        return 'o'                     # organ
    elif bitloc < ns4maps.getLocFromStr( '705-1' ):
        return 'p'                     # piano
    else:
        return 'y'                     # synth

def fxID( paramID, newGroup ):         # convert paramID from a group (here FX piano) to other groups ('o','p','y')
    oldGroup = inferGroupFX( paramID )
    offset = ns4maps.bitsOffsetFX[newGroup] - ns4maps.bitsOffsetFX[oldGroup]
    return ns4maps.shiftBit( paramID, offset )


# ================================================================
#  organ model is different for each layer,
#  but the raw value of organ vib/chorus type is the same for both layers.
#  This function returns the interpreted vib/chorus type for the layer's model.
#
def getVibChorusType( paramdata, layerIndex ):

    model = paramdata['114-2'][layerIndex]['outval']
    model = model.replace( 'B3 BASS', 'B3' )
    model = model.replace( 'PIPE1', 'PIPE' )
    model = model.replace( 'PIPE2', 'PIPE' )
    vctypes = paramdata['110-3'][0]['outval'].split( ';' )
    for vctype in vctypes:
   
        if vctype.strip().startswith( model ):
            words = vctype.split( '->' )
            return words[1].strip()
    return ''

global pan1
global layer
global Win_bg

Win_bg='#bb5050'                              # Cells background color - medium red
Space_bg='#555555'                            # darker grey for space between groups

def DispSection(xtitle,ytitle,title):         # display a section layer (150x100)
    global pan1
    wsect=Frame(pan1,bd=1,relief=SOLID,bg='#bbbbbb')
    wsect.place(x=xtitle,y=ytitle,width=150,height=100)
    wsect1=Frame(wsect,bg='#bbbbbb')
    wsect1.place(width=150-2,height=50)
    title1= Label(wsect1,text=title,font=("Helvetica",20,"bold"),bg='#bbbbbb')
    title1.pack(side=LEFT)
    wsect2=Frame(wsect,bg="#bbbbbb")
    wsect2.place(x=0,y=35,width=150-2,height=50)
    title2= Label(wsect2,text='SECTION',font=("Helvetica",15),bg='#bbbbbb')
    title2.pack(side=LEFT)

def DispLabel(xlabel,ylabel,label):           # display a label (width=150, height=50) 
    global pan1, Win_bg 
    wtitle=Frame(pan1,bd=1,relief=SOLID,bg=Win_bg)
    wtitle.place(x=xlabel,y=ylabel,width=150,height=50)
    name = Label(wtitle,text=label,font=("Helvetica",14,"bold"),bg=Win_bg)
    name.pack(side=BOTTOM)


def DispLabel2(xlabel,ylabel,label):          # display a label (width=150, height=25)
    global pan1, Win_bg 
    wtitle=Frame(pan1,bd=1,relief=SOLID,bg=Win_bg)
    wtitle.place(x=xlabel,y=ylabel,width=150,height=25)
    name = Label(wtitle,text=label,font=("Helvetica",12,"bold"),bg=Win_bg)
    name.pack(side=BOTTOM)

def ValueBckCol(paramID):                     # Background color for values
    global layer

    layer1=layer                              # to avoid key error with organB  
    if paramdata[paramID]['group']=='m':        
        layer1=0                             

    if paramdata[paramID][layer1]['show']:    # if paramID active
        Val_bg='#dd8080'                      # background color = light red
    else:
        Val_bg='#606060'                      # else background color = grey
    return Val_bg    

#==================================       
# Display cell with 1 parameter
# variant=1 : 150x50 variant=2 150x25 variant=3 300x25  
#

def DispCell_1_core(xcell,ycell,paramID,variant):          
    global pan1, Win_bg
    global layer
    
    wcell=Frame(pan1,bd=1,relief=SOLID,bg=Win_bg)
    if variant == 2:
        wcell.place(x=xcell,y=ycell,width=150,height=hC1b)
    elif variant == 3:
        wcell.place(x=xcell,y=ycell,width=300,height=hC1b)
    else:
        wcell.place(x=xcell,y=ycell,width=150,height=hC1)

    #
    # code to support preset files (.ns4o,.ns4n & .ns4y)
    #
    if layer == 0 or paramdata[paramID]['group'] != 'm':
        if 'outval' not in paramdata[paramID][layer].keys():
            paramdata[paramID][layer]['outval'] = ''    
       

    Val_bg= ValueBckCol(paramID)
        
    #
    # special code for organ percu harm 3rd (title in Helvetica 10)
    #
    if paramID=='141-3' :
        title= Label(wcell,text=guinames[paramID],font=("Helvetica",10,"bold"),bg=Win_bg)
    else :
        title= Label(wcell,text=guinames[paramID],font=("Helvetica",12,"bold"),bg=Win_bg)
    if variant >= 2:
        title.pack(side=LEFT)
    else:
        title.pack(side=TOP)
    #
    # special code for piano ID/name & piano variation
    #
    if paramID=='245-5':
        txt=paramdata[paramID][layer]['outval']
        # find the positions of the opening and closing parentheses
        start=txt.find('(')
        end=txt.find(')',start)
        if start != -1 and end != -1 and start < end:
            txt=txt[start+1:end]
            if paramdata['245-3'][layer]['outval'] != 'none':   # concatenation with piano variation if needed
                txt=txt+paramdata['245-3'][layer] ['outval']
                
            value= Label(wcell,text=txt,font=("Helvetica",12),bg=Val_bg)
        else :
            value= Label(wcell,text="Not found",font=("Helvetica",12),bg=Val_bg)
    #
    # code for synth slot/category name
    #
    elif paramID=='408-7':
        txt=paramdata[paramID][layer]['outval']
        # find the position of the category
        start=txt.find('c')
        txt=txt[start+4:len(txt)]
        value= Label(wcell,text=txt,font=("Helvetica",10),bg=Val_bg)
    #
    # code for synth ID/name - only name is displayed
    #
    elif paramID=='410-3':
        txt=paramdata[paramID][layer]['outval']
        # find the positions of the opening and closing parentheses
        start=txt.find('(')
        end=txt.find(')',start)
        if start != -1 and end != -1 and start < end:
            txt=txt[start+1:end]
            value= Label(wcell,text=txt,font=("Helvetica",12),bg=Val_bg)
        else :
            value= Label(wcell,text="Not found",font=("Helvetica",12),bg=Val_bg)      
    #
    # code for arp Gate and Pan (Helvetica 9)
    #
    elif (paramID=='437-3') or (paramID=='441-3'):
          value= Label(wcell,text=paramdata[paramID][layer]['outval'],font=("Helvetica",9),bg=Val_bg)
    #  
    # code for master parameters (no layer 1 or 2) 
    # 
    elif paramdata[paramID]['group']=='m':
        #
        # special code for VIb/Chorus 
        #
        if paramID=='110-3':
            if paramdata['141-1'][layer]['outval']=='off':                         # if vib/chorus = off
                  value= Label(wcell,text="-",font=("Helvetica",12),bg=Val_bg)                 
            else :value= Label(wcell,text=getVibChorusType( paramdata, layer ),font=("Helvetica",12),bg=Val_bg)
        else:
            value= Label(wcell,text=paramdata[paramID][0]['outval'],font=("Helvetica",12),bg=Val_bg) 
 
    else:
        value= Label(wcell,text=paramdata[paramID][layer]['outval'],font=("Helvetica",12),bg=Val_bg)
    if paramID in ['433-3','437-3','441-3']:
          outval = paramdata[paramID][layer]['outval'].replace( '.', '*' )
          value= Label(wcell,text=outval,font=('monospace',9),bg=Val_bg)
    if variant >= 2:
        value.pack(side=RIGHT)
    else:
        value.pack()

def DispCell_1(      xcell,ycell,paramID):                      # cell with 1 parameter 150x50
    DispCell_1_core( xcell,ycell,paramID,1)

def DispCell_1b(     xcell,ycell,paramID):                      # cell with 1 parameter 150x25 
    DispCell_1_core( xcell,ycell,paramID,2)

def DispCell_1c(     xcell,ycell,paramID):                      # cell with 1 parameter 300x25
    DispCell_1_core( xcell,ycell,paramID,3)


def DispCell_2 (xcell,ycell,paramID1,paramID2) :                # display cell (150x50) with 2 parameters
    global pan1, Win_bg  
    global layer
       
    wcell=Frame(pan1,bd=1,relief=SOLID,bg=Win_bg)
    wcell.place(x=xcell,y=ycell,width=150,height=50)
    wcell_1=Frame(wcell,bg=Win_bg)
    wcell_1.place(x=0,y=0,width=75-2,height=50-2)
    title1= Label(wcell_1,text=guinames[paramID1],font=("Helvetica",10,"bold"),bg=Win_bg)
    title1.pack()
    #
    # code to support preset files (.ns4o,.ns4n & .ns4y)
    #
    if layer == 0 or paramdata[paramID1]['group'] != 'm':
        if 'outval' not in paramdata[paramID1][layer].keys():
            paramdata[paramID1][layer]['outval'] = ''
    if layer == 0 or paramdata[paramID2]['group'] != 'm':
        if 'outval' not in paramdata[paramID2][layer].keys():
            paramdata[paramID2][layer]['outval'] = ''

    Val_bg= ValueBckCol(paramID1)
    #  
    # code for master parameters (no layer 1 or 2) 
    #
    if paramdata[paramID1]['group']=='m':
        value1= Label(wcell_1,text=paramdata[paramID1][0]['outval'],font=("Helvetica",12),bg=Val_bg)
    else:
        value1= Label(wcell_1,text=paramdata[paramID1][layer]['outval'],font=("Helvetica",12),bg=Val_bg)
    value1.pack()
    wcell_2=Frame(wcell,bg=Win_bg)
    wcell_2.place(x=75-1,y=0,width=75-2,height=50-2)
    title2= Label(wcell_2,text=guinames[paramID2],font=("Helvetica",10,"bold"),bg=Win_bg)
    title2.pack()

    Val_bg= ValueBckCol(paramID2)   
    #  
    # code for master parameters (no layer 1 or 2) 
    #
    if paramdata[paramID2]['group']=='m':
        value2= Label(wcell_2,text=paramdata[paramID2][0]['outval'],font=("Helvetica",12),bg=Val_bg)
    else:
       value2= Label(wcell_2,text=paramdata[paramID2][layer]['outval'],font=("Helvetica",12),bg=Val_bg)
    value2.pack()

def DispCell_3 (xcell,ycell,paramID1,paramID2,paramID3) :      #  display cell (150x50) with 3 parameters
    global pan1, Win_bg 
    global layer
    
    
    wcell=Frame(pan1,bd=1,relief=SOLID,bg=Win_bg)
    wcell.place(x=xcell,y=ycell,width=150,height=50)
    wcell_1=Frame(wcell,bg=Win_bg)
    wcell_1.place(x=0,y=0,width=50,height=50-2)
    title1= Label(wcell_1,text=guinames[paramID1],font=("Helvetica",8,"bold"),bg=Win_bg)
    title1.pack()
    #
    # code to support preset files (.ns4o,.ns4n & .ns4y)
    #
    if layer == 0 or paramdata[paramID1]['group'] != 'm':
        if 'outval' not in paramdata[paramID1][layer].keys():
            paramdata[paramID1][layer]['outval'] = ''
    if layer == 0 or paramdata[paramID2]['group'] != 'm':
        if 'outval' not in paramdata[paramID2][layer].keys():
            paramdata[paramID2][layer]['outval'] = ''
    if layer == 0 or paramdata[paramID3]['group'] != 'm':
        if 'outval' not in paramdata[paramID3][layer].keys():
            paramdata[paramID3][layer]['outval'] = '' 

    Val_bg= ValueBckCol(paramID1)
    #  
    # code for master parameters (no layer 1 or 2) 
    #
     
    if paramdata[paramID1]['group']=='m':
        if paramID1=='206-1' :                                    # special case of morph tempo
               txt=paramdata[paramID1][0]['outval']
               # find the position of the opening parenthese
               start=txt.find('(')
               if start != -1:
                   txt=txt[:start-1]
               value1= Label(wcell_1,text=txt,font=("Helvetica",8),bg=Val_bg)     
        else :    
           value1= Label(wcell_1,text=paramdata[paramID1][0]['outval'],font=("Helvetica",8),bg=Val_bg)
    else:
        if (paramID1=='298-1') or (paramID1=='736-1') :           # special case of morph tempo
               txt=paramdata[paramID1][layer]['outval']
               # find the position of the opening parenthese
               start=txt.find('(')
               if start != -1:
                   txt=txt[:start-1]
               value1= Label(wcell_1,text=txt,font=("Helvetica",8),bg=Val_bg)         
        else :
            value1= Label(wcell_1,text=paramdata[paramID1][layer]['outval'],font=("Helvetica",8),bg=Val_bg)
            
    value1.pack()
    wcell_2=Frame(wcell,bg=Win_bg)
    wcell_2.place(x=50,y=0,width=50,height=50-2)
    title2= Label(wcell_2,text=guinames[paramID2],font=("Helvetica",8,"bold"),bg=Win_bg)
    title2.pack()

    Val_bg= ValueBckCol(paramID2)
    #  
    # code for master parameters (no layer 1 or 2) 
    #
    if paramdata[paramID2]['group']=='m':
        if paramID2=='207-1' :                                    # special case of morph tempo
               txt=paramdata[paramID2][0]['outval']
               # find the position of the opening parenthese
               start=txt.find('(')
               if start != -1:
                   txt=txt[:start-1]
               value2= Label(wcell_2,text=txt,font=("Helvetica",8),bg=Val_bg)     
        else :    
           value2= Label(wcell_2,text=paramdata[paramID2][0]['outval'],font=("Helvetica",8),bg=Val_bg)
    else:
        if (paramID2=='299-1') or (paramID2=='737-1') :           # special case of morph tempo
               txt=paramdata[paramID2][layer]['outval']
               # find the position of the opening parenthese
               start=txt.find('(')
               if start != -1:
                   txt=txt[:start-1]
               value2= Label(wcell_2,text=txt,font=("Helvetica",8),bg=Val_bg)         
        else :
           value2= Label(wcell_2,text=paramdata[paramID2][layer]['outval'],font=("Helvetica",8),bg=Val_bg)
           
    value2.pack()
    wcell_3=Frame(wcell,bg=Win_bg)
    wcell_3.place(x=100-1,y=0,width=50-1,height=50-2)

    title3= Label(wcell_3,text=guinames[paramID3],font=("Helvetica",8,"bold"),bg=Win_bg)
    title3.pack()

    Val_bg= ValueBckCol(paramID3)
    #  
    # code for master parameters (no layer 1 or 2) 
    #
    if paramdata[paramID3]['group']=='m':
        if paramID3=='208-1' :                                    # special case of morph tempo
               txt=paramdata[paramID3][0]['outval']
               # find the position of the opening parenthese
               start=txt.find('(')
               if start != -1:
                   txt=txt[:start-1]
               value3= Label(wcell_3,text=txt,font=("Helvetica",8),bg=Val_bg)     
        else :    
           value3= Label(wcell_3,text=paramdata[paramID3][0]['outval'],font=("Helvetica",8),bg=Val_bg)
    else:
        if (paramID3=='300-1') or (paramID3=='738-1') :           # special case of morph tempo
               txt=paramdata[paramID3][layer]['outval']
               # find the position of the opening parenthese
               start=txt.find('(')
               if start != -1:
                   txt=txt[:start-1]
               value3= Label(wcell_3,text=txt,font=("Helvetica",8),bg=Val_bg)         
        else :
           value3= Label(wcell_3,text=paramdata[paramID3][layer]['outval'],font=("Helvetica",8),bg=Val_bg)

    value3.pack()

def DispSubSection0(xtitle,ytitle,title):             # display on/off in title of a subsection
    global pan1, Win_bg
    wtitle=Frame(pan1,bd=0,relief=SOLID,bg='#bbbbbb')
    wtitle.place(x=xtitle,y=ytitle+1,width=wSS0-1,height=hSS-2)
    name = Label(wtitle,text=title,font=("Helvetica",14,"bold"),bg='#bbbbbb')
    name.pack(side=BOTTOM)

def DispSubSection1(xtitle,ytitle,title):             # display title of a subsection (width=150,height=25)
    global pan1, Win_bg
    wtitle=Frame(pan1,bd=1,relief=SOLID,bg='#bbbbbb')
    wtitle.place(x=xtitle,y=ytitle,width=150,height=25)
    name = Label(wtitle,text=title,font=("Helvetica",14,"bold"),bg='#bbbbbb')
    name.pack(side=BOTTOM)
    
def DispSubSection1H(xtitle,ytitle,title):            # display title of a subsection (width=150,height=25)
                                                      # with small font (Helvetica=10)
    global pan1, Win_bg
    wtitle=Frame(pan1,bd=1,relief=SOLID,bg='#bbbbbb')
    wtitle.place(x=xtitle,y=ytitle,width=150,height=25)
    name = Label(wtitle,text=title,font=("Helvetica",10,"bold"),bg='#bbbbbb')
    name.pack(side=BOTTOM)

def DispSubSection2(xtitle,ytitle,title):             # display title of a subsection  (width=300,height=25))
    global pan1, Win_bg
    wtitle=Frame(pan1,bd=1,relief=SOLID,bg='#bbbbbb')
    wtitle.place(x=xtitle,y=ytitle,width=300,height=25)
    name = Label(wtitle,text=title,font=("Helvetica",14,"bold"),bg='#bbbbbb')
    name.pack(side=BOTTOM)

def DispSubSection3(xtitle,ytitle,title):             # display title of a subsection   (width=450,height=25)
    global pan1, Win_bg
    wtitle=Frame(pan1,bd=1,relief=SOLID,bg='#bbbbbb')
    wtitle.place(x=xtitle,y=ytitle,width=450,height=25)
    name = Label(wtitle,text=title,font=("Helvetica",14,"bold"),bg='#bbbbbb')
    name.pack(side=BOTTOM)

def DispSubSection4(xtitle,ytitle,title):             # display title of a subsection   (width=750,height=25)
    global pan1, Win_bg
    wtitle=Frame(pan1,bd=1,relief=SOLID,bg='#bbbbbb')
    wtitle.place(x=xtitle,y=ytitle,width=600,height=25)
    name = Label(wtitle,text=title,font=("Helvetica",14,"bold"),bg='#bbbbbb')
    name.pack(side=BOTTOM)

def DispSubSection5(xtitle,ytitle,title):             # display title of a subsection   (width=750,height=25)
    global pan1, Win_bg
    wtitle=Frame(pan1,bd=1,relief=SOLID,bg='#bbbbbb')
    wtitle.place(x=xtitle,y=ytitle,width=750,height=25)
    name = Label(wtitle,text=title,font=("Helvetica",14,"bold"),bg='#bbbbbb')
    name.pack(side=BOTTOM)

def DispCells(sublist):                               # decode Cells list and call the corresponding function    
    if   sublist[0] == "Section":
         DispSection(sublist[1],sublist[2],sublist[3])
    elif sublist[0] == "Label":
         DispLabel(sublist[1],sublist[2],sublist[3])
    elif sublist[0] == "Label2":
         DispLabel2(sublist[1],sublist[2],sublist[3])
    elif sublist[0] == "Cell_1" :
         DispCell_1(sublist[1],sublist[2],sublist[3])
    elif sublist[0] == "Cell_1b" :
         DispCell_1b(sublist[1],sublist[2],sublist[3])
    elif sublist[0] == "Cell_1c" :
         DispCell_1c(sublist[1],sublist[2],sublist[3])
    elif sublist[0] == "Cell_2" :
         DispCell_2(sublist[1],sublist[2],sublist[3],sublist[4])
    elif sublist[0] == "Cell_3" :
         DispCell_3(sublist[1],sublist[2],sublist[3],sublist[4],sublist[5])
    elif sublist[0] == "SubSection0":
         DispSubSection0(sublist[1],sublist[2],sublist[3])
    elif sublist[0] == "SubSection1":
         DispSubSection1(sublist[1],sublist[2],sublist[3])
    elif sublist[0] == "SubSection1H":
         DispSubSection1H(sublist[1],sublist[2],sublist[3])
    elif sublist[0] == "SubSection2":
         DispSubSection2(sublist[1],sublist[2],sublist[3])
    elif sublist[0] == "SubSection3":
         DispSubSection3(sublist[1],sublist[2],sublist[3])
    elif sublist[0] == "SubSection4":
         DispSubSection4(sublist[1],sublist[2],sublist[3])
    elif sublist[0] == "SubSection5":
         DispSubSection5(sublist[1],sublist[2],sublist[3])
    else : print("error within Cells type")
    


    # =========================================   
    #  
    #  GLOBAL Page
    #
    # =========================================

def GLOBALpan(page,section_name):

    global pan1, Win_bg 


    
    pan1=Frame(page,bg=Space_bg)
    pan1.place(width=1480,height=775)


    #==========================================
    # Cells contains the definition of each cell
    # [type of cell, x, y, parm1, parm2, parm3]
    #

    Cells = ([
        ["Section",0,0,section_name,None,None],           # Section Label
    ])
    w0 = 50
    h0 = 150
    Cells.extend([
        ["SubSection1",w0,h0,"File info",None,None],      # File info 
        ["Cell_2",w0,h0+hSS,'009-1','021-1',None],        # File type & file version
        ["Cell_2",w0,h0+hSS+hC1,'013-6','015-3',None],    # Bank & location in bank
    ])
    w0 = 50
    h0 = 400
    Cells.extend([
        ["SubSection1",w0,h0,"Tranpose",None,None],       # Transpose       
        ["Cell_1",w0,h0+hSS,'052-7',None,None],           # Program tranpose on/off & amount
        ["Cell_1",w0,h0+hSS+hC1,'052-8',None,None],
    ])
    w0 = 550
    h0 = 110
    Cells.extend([
        ["SubSection1",w0,h0,"Active scene",None,None],   # Active layer    
        ["Cell_1",w0,h0+hSS,'085-3',None,None],           # layer scene active
    ])
    w0 = 450
    h0 = 425
    Cells.extend([
        ["SubSection3",w0,h0,"Split",None,None],                                      # Split 
        ["SubSection0",w0+wSS3-wSS0,h0,paramdata['050-1'][0]['outval'],None,None],    # Split on/off

        # display these from the bottom up so that the labels of the lower cells are masked

        ["Cell_1",w0+0*wC1,h0+1*hSS+hC1,'052-1',None,None],                           # KB zones split point Xfade
        ["Cell_1",w0+1*wC1,h0+1*hSS+hC1,'052-3',None,None],    
        ["Cell_1",w0+2*wC1,h0+1*hSS+hC1,'052-5',None,None],
 
        ["Cell_1",w0+0*wC1,h0+0*hSS+hC1,'050-5',None,None],                           # KB zones split point  
        ["Cell_1",w0+1*wC1,h0+0*hSS+hC1,'051-1',None,None],
        ["Cell_1",w0+2*wC1,h0+0*hSS+hC1,'051-5',None,None],

        ["Cell_1",w0+0*wC1,h0+1*hSS,'050-2',None,None],                               # KB zones split point on/off   
        ["Cell_1",w0+1*wC1,h0+1*hSS,'050-3',None,None],
        ["Cell_1",w0+2*wC1,h0+1*hSS,'050-4',None,None],

        ["Label2",w0-1*wC1,h0+3*hSS,"split point",None,None],
        ["Label2",w0-1*wC1,h0+4*hSS,"XFade",None,None],
    ])
    w0 = 850
    h0 = hPad+2*hC1
    Cells.extend([
        ["SubSection3",w0,h0,"Section (scene I)",None,None],                           # Section on/off organ, piano, synth
        ["Cell_1",w0,      h0+hSS,'084-5',None,None],
        ["Cell_1",w0+wC1,  h0+hSS,'084-6',None,None],
        ["Cell_1",w0+2*wC1,h0+hSS,'084-7',None,None],
        ["SubSection3",w0, h0+hSS+hC1+hPad,"Section (scene II)",None,None],            # Section on/off scene II organ, piano, synth
        ["Cell_1",w0,      h0+2*hSS+hC1+hPad,'084-8',None,None],
        ["Cell_1",w0+wC1,  h0+2*hSS+hC1+hPad,'085-1',None,None],
        ["Cell_1",w0+2*wC1,h0+2*hSS+hC1+hPad,'085-2',None,None],
        ["Cell_1",w0+wC1,  h0+2*hSS+2*hC1+2*hPad,'088-4',None,None],                   # FX on/off 

           
    ])


    for sublist in Cells:
        DispCells(sublist)

        
    # ********************************
    #
    #  PIANO panel
    #
    # *******************************
    
def PIANOpan(page,section_name):

    global pan1, Win_bg     


    
    pan1=Frame(page,bg=Space_bg)
    pan1.place(width=wSection,height=775)

    x0=225
    y0=50

    Cells = [
        ["Section",x0,y0,section_name,None,None],        # Section Label
        ["Cell_1",x0,y0+100,'230-7',None,None],          # Volume
        ["Label",x0,y0+150,"Morph",None,None],           # Volume morph
        ["Cell_3",x0,y0+200,'231-6','232-6','233-6'],
        ["Cell_2",x0,y0+250,'244-2','244-1',None],       # Sustped & PSTICK
        ["Cell_1",x0,y0+300,'250-7',None,None],          # Timbre
        ["Cell_1",x0,y0+350,'243-5',None,None],          # Octave shift
        ["Cell_1",x0,y0+400,'243-1',None,None],          # KB Zone
        ["Label",x0+150,y0,"Layer",None,None],           # Layer
        ["Cell_2",x0+150,y0+50,'230-3','230-6',None],
        ["Label",x0+150,y0+100,"Acoustics",None,None],   # Acoustics
        ["Cell_3",x0+150,y0+150,'249-5','249-6','249-7'],
        ["Cell_1",x0+150,y0+200,'250-2'],                # Unison
        ["Cell_1",x0+150,y0+250,'249-8'],                # KB touch
        ["Cell_1",x0+150,y0+300,'250-4'],                # Dyn comp
        ["Cell_1",x0+150,y0+350,'244-3'],                # Piano type
        ["Cell_1",x0+150,y0+400,'245-5']                 # Piano name 
    ]


    for sublist in Cells:
        DispCells(sublist)

        
    # ********************************
    #
    #  ORGAN panel
    #
    # *******************************

       
def ORGANpan(page,section_name):

    global pan1, Win_bg  



    
    pan1=Frame(page,bg=Space_bg)
    pan1.place(width=wSection,height=775)

    yrot=150                                                       # y start for rotary speaker   

    ydraw = 440
    Cells = [
        ["Section",160,0,section_name,None,None],                  # Section Label
        ["Cell_1",160,100,'095-7',None,None],                      # Volume
        ["Label",160,150,"Morph",None,None],                       # Volume morph
        ["Cell_3",160,200,'096-6','097-6','098-6'],
        ["Cell_2",160,250,'114-1','103-5',None],                   # Sustped & Pstick 
        ["Cell_2",160,300,'113-5','114-5',None],                   # Octave shift + preset 
        ["Cell_1",160,350,'113-1',None,None],                      # KB Zone
        ["Label",310,0,"Layer",None,None],                         # Layer
        ["Cell_2",310,50,'095-3','095-6',None],
        ["Cell_1",310,100,'114-2',None,None],                      # organ model
        ["Cell_1",310,150,'141-1',None,None],                      # vib/chorus on/off
        ["Cell_1",310,200,'110-3',None,None],                      # vib/chorus type
        ["Cell_1",310,250,'141-2',None,None],                      # percussion on/off
        ["Cell_2",310,300,'141-5','141-4',None],                   # vol soft, decay fast
        ["Cell_1",310,350,'141-3',None,None],                      # & harm 3rd
        ["Label",470,0,"Drawbar morph",None,None],                 # drawbars morph
        ["Cell_3",470,50,'117-5','118-2','118-7'],                 # drawbar 1 
        ["Cell_3",470,100,'119-8','120-5','121-2'],                # drawbar 2
        ["Cell_3",470,150,'122-3','122-8','123-5'],                # drawbar 3
        ["Cell_3",470,200,'124-6','125-3','125-8'],                # drawbar 4
        ["Cell_3",470,250,'127-1','127-6','128-3'],                # drawbar 5
        ["Cell_3",470,300,'129-4','130-1','130-6'],                # drawbar 6
        ["Cell_3",470,350,'131-7','132-4','133-1'],                # drawbar 7
        ["Cell_3",620,300,'134-2','134-7','135-4'],                # drawbar 8
        ["Cell_3",620,350,'136-5','137-2','137-7'],                # drawbar 9       
        ["SubSection1H",150,ydraw    ,"BASS16 STR16 FLUTE8",None,None],  # labels for the graph. drawbars 
        ["SubSection1H",300,ydraw    ,"OBOE8 TRMP8  STR8",None,None],
        ["SubSection1H",450,ydraw    ,"FLUTE4   STR4   2 2/3 ",None,None],
        ["SubSection1", 150,ydraw+225," 16'   5 1/3'  8'",None,None],   
        ["SubSection1", 300,ydraw+225," 4'    2 2/3'  2'",None,None],
        ["SubSection1", 450,ydraw+225,"1 3/5'  1 1/3'   1' ",None,None], 



        ["SubSection1",0,yrot,"Rotary spkr",None,None],            # Rotary speaker
        ["Cell_1",0,yrot+25,'104-1',None,None],                    # Organ off/on     
        ["Cell_1",0,yrot+75,'105-5',None,None],                    # drive
        ["Label2",0,yrot+125,"Stop",None,None],                    # filler
        ["Cell_2",0,yrot+150,'109-3','108-5',None],                # stop mode (off/on) & angle (stop position) 
        ["Cell_1",0,yrot+200,'109-4',None,None],                   # slow/fast

   ]

    for sublist in Cells:
        DispCells(sublist)



    xdraw=150
    ydraw=ydraw+25
    
    var1 = IntVar()
    var2 = IntVar()
    var3 = IntVar()
    var4 = IntVar()
    var5 = IntVar()
    var6 = IntVar()
    var7 = IntVar()
    var8 = IntVar()
    var9 = IntVar() 
    
    Scale(pan1,length=200,width=30,orient=VERTICAL,variable=var1,bg='black',
          troughcolor='dark grey', sliderlength=20,state=DISABLED,fg='white',
          showvalue=0, from_=0, to=8, tickinterval=1).place(x=xdraw,y=ydraw)
    var1.set(paramdata['117-1'][layer]['outval'])
    Scale(pan1,length=200,width=30,orient=VERTICAL,variable=var2,bg='black',
          troughcolor='dark grey', sliderlength=20,state=DISABLED,fg='white',
          showvalue=0, from_=0, to=8, tickinterval=1).place(x=xdraw+50,y=ydraw)
    var2.set(paramdata['119-4'][layer]['outval'])    
    Scale(pan1,length=200,width=30,orient=VERTICAL,variable=var3,bg='white',
          troughcolor='dark grey', sliderlength=20,state=DISABLED,fg='black',
          showvalue=0, from_=0, to=8, tickinterval=1).place(x=xdraw+100,y=ydraw)
    var3.set(paramdata['121-7'][layer]['outval'])
    Scale(pan1,length=200,width=30,orient=VERTICAL,variable=var4,bg='white',
          troughcolor='dark grey', sliderlength=20,state=DISABLED,fg='black',
          showvalue=0, from_=0, to=8, tickinterval=1).place(x=xdraw+150,y=ydraw)
    var4.set(paramdata['124-2'][layer]['outval'])
    Scale(pan1,length=200,width=30,orient=VERTICAL,variable=var5,bg='black',
          troughcolor='dark grey', sliderlength=20,state=DISABLED,fg='white',
          showvalue=0, from_=0, to=8, tickinterval=1).place(x=xdraw+200,y=ydraw)
    var5.set(paramdata['126-5'][layer]['outval'])    
    Scale(pan1,length=200,width=30,orient=VERTICAL,variable=var6,bg='white',
          troughcolor='dark grey', sliderlength=20,state=DISABLED,fg='black',
          showvalue=0, from_=0, to=8, tickinterval=1).place(x=xdraw+250,y=ydraw)
    var6.set(paramdata['128-8'][layer]['outval'])
    Scale(pan1,length=200,width=30,orient=VERTICAL,variable=var7,bg='black',
          troughcolor='dark grey', sliderlength=20,state=DISABLED,fg='white',
          showvalue=0, from_=0, to=8, tickinterval=1).place(x=xdraw+300,y=ydraw)
    var7.set(paramdata['131-3'][layer]['outval'])
    Scale(pan1,length=200,width=30,orient=VERTICAL,variable=var8,bg='black',
          troughcolor='dark grey', sliderlength=20,state=DISABLED,fg='white',
          showvalue=0, from_=0, to=8, tickinterval=1).place(x=xdraw+350,y=ydraw)
    var8.set(paramdata['133-6'][layer]['outval'])    
    Scale(pan1,length=200,width=30,orient=VERTICAL,variable=var9,bg='white',
          troughcolor='dark grey', sliderlength=20,state=DISABLED,fg='black',
          showvalue=0, from_=0, to=8, tickinterval=1).place(x=xdraw+400,y=ydraw)
    var9.set(paramdata['136-1'][layer]['outval'])

    
    # ********************************
    #
    #  FX panel
    #
    # *******************************

    # note : the indexes are defined for the piano FX. fxID translates for the other groups 
     
def FXpan(page,group):

    global pan1, Win_bg


    pan1 = Frame(page, bg =Space_bg, bd =2, relief =GROOVE)
    pan1.place(x=wSection,width=750,height=775)

 #
 #  code to avoid layer 1 for Organ parameters (not defined)
 #
    if group=='o':
        Mstclk      = paramdata[fxID('267-2',group)][0]['outval']
        Mod1OnOff   = paramdata[fxID('267-1',group)][0]['outval']
        Mod2OnOff   = paramdata[fxID('275-5',group)][0]['outval']
        AmpEQOnOff  = paramdata[fxID('283-8',group)][0]['outval']
        DelayOnOff  = paramdata[fxID('296-1',group)][0]['outval']
        ReverbOnOff = paramdata[fxID('312-4',group)][0]['outval']
        CompOnOff   = paramdata[fxID('294-8',group)][0]['outval']
    else: 
        Mstclk      = paramdata[fxID('267-2',group)][layer]['outval']    
        Mod1OnOff   = paramdata[fxID('267-1',group)][layer]['outval']
        Mod2OnOff   = paramdata[fxID('275-5',group)][layer]['outval']
        AmpEQOnOff  = paramdata[fxID('283-8',group)][layer]['outval']
        DelayOnOff  = paramdata[fxID('296-1',group)][layer]['outval']
        ReverbOnOff = paramdata[fxID('312-4',group)][layer]['outval']
        CompOnOff   = paramdata[fxID('294-8',group)][layer]['outval']

    Cells = []

    w0 = wPad
    h0 = 0
    Cells.extend( [ 
        ["SubSection4", w0, h0, "L  A  Y  E  R      E  F  F  E  C  T  S",None,None]    # layer effects
    ])
    w0 = wPad+0
    h0 = hPad+hSS
    Cells.extend( [
        ["SubSection2",w0+  0, h0, "M O D  1",None,None],                               # label
        ["SubSection0",w0+wSS2-wSS0,h0, Mod1OnOff,None,None],                           # On/Off
        ["Cell_1",    w0+150, h0+hSS+hC1b+hC3, fxID('275-1',group),None,None],          # mode
        ["Cell_1b",    w0+  0, h0+hSS, fxID('267-3',group),None,None],                  # Rate
        ["Cell_3",     w0+  0, h0+hSS+hC1b, fxID('268-2',group), \
                                             fxID('269-2',group), \
                                             fxID('270-2',group)],                      # Morph
        ["Label2",     w0+  0, h0+hSS+hC1b+hC3, "MST CLK "+Mstclk,None,None],           # MST CLOCK 
        ["Cell_1b",    w0+150, h0+hSS, fxID('271-2',group),None,None],                  # Amount
        ["Cell_3",     w0+150, h0+hSS+hC1b, fxID('272-1',group), \
                                             fxID('273-1',group), \
                                             fxID('274-1',group)]                       # Morph
    ])
    w0 = wPad+0
    h0 = 2*hPad+hSS+hSS+hC1b+hC3+hC1
    Cells.extend( [
        ["SubSection2",w0+  0, h0, "M O D  2",None,None],                               # label
        ["SubSection0",w0+wSS2-wSS0,h0, Mod2OnOff,None,None],                           # On/Off
        ["Cell_1c",    w0+  0, h0+hSS+hC1b+hC3, fxID('283-4',group),None,None],         # mode
        ["Cell_1b",    w0+  0, h0+hSS, fxID('275-6',group),None,None],                  # Rate
        ["Cell_3",     w0+  0, h0+hSS+hC1b, fxID('276-5',group), \
                                             fxID('277-5',group), \
                                             fxID('278-5',group)],                      # Morph
        ["Cell_1b",    w0+150, h0+hSS, fxID('279-5',group),None,None],                  # Amount
        ["Cell_3",     w0+150, h0+hSS+hC1b, fxID('280-4',group), \
                                             fxID('281-4',group), \
                                             fxID('282-4',group)]                       # Morph
    ])
    w0 = 2*wPad+300
    h0 = hPad+hSS
    Cells.extend( [
        ["SubSection2",w0,h0,"D  E  L  A  Y",None,None],                                            # DELAY label
        ["SubSection0",w0+wSS2-wSS0,h0,DelayOnOff,'055-1',None] ,                                   # Delay On/Off & global 
        ["Cell_1",w0,h0+hSS,fxID('311-8',group),None,None],                                         # Effects
        ["Cell_1",w0,h0+hSS+hC1,fxID('296-3',group),None,None],                                     # Tempo
        ["Cell_3",w0,h0+hSS+2*hC1,fxID('298-1',group),fxID('299-1',group),fxID('300-1',group)],     # Morph
        ["Cell_1b",w0,h0+hSS+3*hC1,fxID('296-2',group),None,None],                                  # MST CLK
        ["Cell_1",w0,h0+hSS+3*hC1+hC1b,fxID('307-5',group),None,None],                              # Normal/Analog
        ["Cell_1b",w0+150,h0+hSS+2*hC1+hC1b,fxID('303-6',group),None,None],                         # Mix (Dry/Wet)
        ["Cell_3",w0+150,h0+hSS+2*hC1+2*hC1b,fxID('304-5',group),fxID('305-5',group),fxID('306-5',group)],   # Morph 
        ["Cell_1b",w0+150,h0+hSS,fxID('308-1',group),None,None],                                    # Feedback 
        ["Cell_3",w0+150,h0+hSS+hC1b,fxID('308-8',group),fxID('309-8',group),fxID('310-8',group)],  # Morph
        ["Cell_2",w0+150,h0+hSS+hC1b+hC1,fxID('307-7',group),fxID('307-6',group),None],              # Filter type & ping-pong
        ["Cell_1b",w0+150,h0+hSS+3*hC1+2*hC1b,'055-1',None,None],                                   # Global  
    ])
    w0 = wPad+0
    h0 = 3*hPad+hSS+hSS+hC1b+hC3+hC1+hSS+hC1b+hC3+hC1b
    Cells.extend( [
        ["SubSection2",w0,h0,"A M P  SIM/EQ",None,None],                                              # AMP SIM/EQ label
        ["SubSection0",w0+wSS2-wSS0,h0,AmpEQOnOff,None,None],                                         # Amp sim/EQ on/off
        ["Cell_1",w0+150,h0+hSS,fxID('317-6',group),None,None],                                       # mode
        ["Cell_1b",w0,  h0+hSS,fxID('290-5',group),None,None],                                        # drive
        ["Cell_3",w0,h0+hSS+hC1b,fxID('291-4',group),fxID('292-4',group),fxID('293-4',group)],        # Morph
        ["Cell_1",w0+150,h0+hSS+hC1,fxID('286-6',group),None,None],                                   # Mid frequency
        ["Cell_3",w0+150,h0+hSS+hC1+hC1,fxID('287-5',group),fxID('288-5',group),fxID('289-5',group)], # Morph
        ["Label2",w0+0,h0+hSS+hC1b+hC1,"EQ",None,None],                                               # EQ
        ["Cell_3",w0+0,h0+hSS+hC1b+hC1+hC1b,fxID('285-7',group),fxID('284-8',group),fxID('284-1',group)]
    ])
    w0 = wPad+225
    h0 = 4*hPad+hSS+3*hSS+3*hC1b+6*hC1
    Cells.extend( [
        ["SubSection1",w0,h0,"COMP",None,None],                                      # COMP label
        ["SubSection0",w0+wSS1-wSS0,h0,CompOnOff,None,None],                         # Comp On/Off
        ["Cell_1",w0,h0+hSS,fxID('295-1',group),None,None],                          # Amount
        ["Cell_1",w0,h0+hSS+hC1,fxID('295-8',group),None,None],                      # Response
        ["Cell_1",w0,h0+hSS+hC1+hC1,'054-8',None,None]                               #  global
    ])
    w0 = 2*wPad+300
    h0 = 3*hPad+2*hSS+4*hC1+hC1b
    Cells.extend( [
        ["SubSection2",w0,h0,"R E V E R B",None,None],                                  # REVERB label
        ["SubSection0",w0+wSS2-wSS0,h0,ReverbOnOff,None,None],                          # Reverb on/off
        ["Cell_1",w0+150,h0+hSS,fxID('316-6',group),None,None],                         # Type
        ["Cell_1",w0,h0+hSS,fxID('316-4',group),None,None],                             # Dark/Bright 
        ["Cell_1b",w0,h0+hSS+hC1,fxID('312-5',group),None,None],                        # Amount
        ["Cell_3",w0,h0+hSS+hC1+hC1b,fxID('313-4',group),fxID('314-4',group),fxID('315-4',group)],   # Morph
        ["Cell_1",w0+150,h0+hSS+hC1,'055-2',None,None]                                  # global

     ] )
    
    for sublist in Cells:
        DispCells(sublist)  


    # ********************************
    #
    #  SYNTH A panel
    #
    # *******************************

def SYNTHpan(page,section_name):

    global pan1, Win_bg

    
    pan1=Frame(page,bg=Space_bg)
    pan1.place(width=wSection,height=775)
   
    Cells = []

    Cells.extend( [
        ["Section",0,0,section_name,None,None],                        # Section Label
    ])
    w0 = 0
    h0 = 100
    Cells.extend( [
        ["Label2",w0,h0,"Layer",None,None],                             # Layer
        ["Cell_2",w0,h0+hSS,'377-5','378-2',None],
        ["Cell_1b",w0,h0+hSS+hC1,'378-3',None,None],                    # Volume
        ["Cell_3",w0,h0+2*hSS+hC1,'379-2','380-2','381-2'],             # Volume morph
        ["Cell_1b",w0,h0+2*hSS+2*hC1,'389-8',None,None],                # Pan
        ["Cell_1b",w0,h0+3*hSS+2*hC1,'415-8',None,None],                # Sustped
        ["Cell_2",w0,h0+4*hSS+2*hC1,'415-3','415-4',None],              # Pstick & range        
        ["Cell_2",w0,h0+4*hSS+3*hC1,'401-8','423-7',None,None],         # KB hold & Exclude
        ["Cell_2",w0,h0+4*hSS+4*hC1,'423-8','424-4',None,None],         # Arp run & KB sync
        ["Cell_1",w0,h0+4*hSS+5*hC1,'414-7',None,None],                 # Octave shift
        ["Cell_1",w0,h0+4*hSS+6*hC1,'414-3',None,None],                 # KB Zone
    ])
    w0 = wPad+150
    h0 = 0
    Cells.extend( [
        ["SubSection2",w0,h0,"OSC WAVEFORM",None,None],                 # OSC Waveform
        ["Cell_1c",    w0,h0+hSS,'408-1',None,None],                    # Samples/Analog
        ["SubSection2",w0,h0+2*hSS,"ANALOG",None,None],                 # Label Analog
        ["Cell_1c",    w0,h0+3*hSS,'561-3',None,None],                  # Type
        ["Cell_1c",    w0,h0+4*hSS,'561-8',None,None],                  # cat
        ["Cell_1c",    w0,h0+5*hSS,'562-4',None,None],                  # Wave/partial
        ["SubSection2",w0,h0+6*hSS,"SAMPLE",None,None],                 # Label Wave
        ["Cell_1c",    w0,h0+7*hSS,'408-7',None,None],                  # Slot/Category name 
        ["Cell_1c",    w0,h0+8*hSS,'410-3',None,None],                  # Sample ID/name
        ["Cell_1c",    w0,h0+9*hSS,'575-6',None,None],                  # Options 
        ["Cell_1c",    w0,h0+10*hSS,'604-3',None,None],                 # bright
        ["SubSection2",w0,h0+11*hSS,"EXTERN",None,None],                # Extern
        ["SubSection0",w0+wSS2-wSS0,h0+ 11*hSS,paramdata['418-1'][layer]['outval'],None,None],  #  Extern on/off
        ["Cell_1c",    w0,    h0+12*hSS,'421-8',None,None],             # Extern program
        ["Cell_1b",    w0,    h0+13*hSS,'445-5',None,None],             # CC Val 1
        ["Cell_3",     w0,    h0+14*hSS,'446-4','447-4','448-4'],       # Morph
        ["Cell_1b",    w0+150,h0+13*hSS,'449-4',None,None],             # CC Val 2
        ["Cell_3",     w0+150,h0+14*hSS,'450-3','451-3','452-3'],       # Morph
    ])
    w0 = wPad+150
    h0 = hPad+10*hSS+3*hC1
    Cells.extend( [
        ["SubSection1",w0,h0,"L F O",None,None],                         # LFO
        ["Cell_1b",w0,h0+hSS,'576-6',None,None],                         # LFO rate/time
        ["Cell_3",w0,h0+hSS+hC1b,'577-5','578-5','579-5'],               # Morph
        ["Label2",w0,h0+hSS+hC1b+hC1,"MST CLK "+paramdata['576-5'][layer]['outval'],None,None], # MST CLOCK
        ["Cell_1",w0,h0+hSS+2*hC1b+hC1,'580-5',None,None],               # Mod amt
        ["Cell_3",w0,h0+hSS+2*hC1b+2*hC1,'581-4','582-4','583-4'],       # Morph
        ["Cell_1b",w0,h0+hSS+2*hC1b+3*hC1,'575-8',None,None],            # Target
        ["Cell_1b",w0,h0+hSS+3*hC1b+3*hC1,'576-2',None,None],            # Shape
    ])
    w0 =wPad+300
    h0 = hPad+10*hSS+3*hC1
    Cells.extend( [
        ["SubSection1",w0,h0,"OSCILLATORS",None,None],                   # Oscillators
        ["Cell_2",w0,h0+hSS,'575-4','575-5',None,None],                  # Env to pitch & velocity
        ["Cell_2",w0,h0+hSS+hC1,'567-8','567-1',None],                   # pitch coarse & fine
        ["Cell_3",w0,h0+hSS+2*hC1,'568-8','569-7','570-6'],              # ADR
        ["Cell_1b",w0,h0+hSS+3*hC1,'563-2',None,None],                   # Osc Ctrl
        ["Cell_3",w0,h0+2*hSS+3*hC1,'564-1','565-1','566-1'],            # Morph
        ["Cell_1b",w0,h0+2*hSS+4*hC1,'571-5',None,None],                 # Osc env amount
        ["Cell_3",w0,h0+3*hSS+4*hC1,'572-4','573-4','574-4'],            # Morph
    ])
    w0 = 2*wPad+450
    h0 = 0
    Cells.extend( [
        ["SubSection2",w0,h0,"ARPEGGIATOR/GATE",None,None],              # Arpeggiator
        ["Cell_1",w0,h0+hSS,'428-8',None,None],                          # Rate/time
        ["Cell_3",w0,h0+hSS+hC1,'429-7','430-7','431-7'],                # Morph
        ["Label2",w0,h0+hSS+2*hC1,"MST CLK "+paramdata['428-7'][layer]['outval'],None,None], # MST CLOCK
        ["Cell_2",w0,h0+2*hSS+2*hC1,'428-4','428-6',None],               # Direction & zigzag
        ["Cell_2",w0,h0+2*hSS+3*hC1,'424-1','424-3',None],               # Mode & pattern
        ["Cell_1b",w0,h0+2*hSS+4*hC1,'432-7',None,None],                 # pattern length
        ["Cell_1",w0+wC1,h0+hSS+0*hC1,'424-5',None,None],                # Range/env
        ["Cell_3",w0+wC1,h0+hSS+1*hC1,'425-4','426-4','427-4'],          # Morph
        ["Cell_1",w0+wC1,h0+hSS+2*hC1,'433-3',None,None],                # pattern accent
        ["Cell_1",w0+wC1,h0+hSS+3*hC1,'437-3',None,None],                # pattern gate
        ["Cell_1",w0+wC1,h0+hSS+4*hC1,'441-3',None,None],                # pattern pan
    ])
    w0 = 2*wPad+450
    h0 = hPad+hSS+5*hC1
    Cells.extend( [
        ["SubSection1",w0,h0,"FILTER",None,None],                        # Filter
        ["SubSection0",w0+wSS1-wSS0,h0,paramdata['602-5'][layer]['outval'],None,None],  # Filter on/off
        ["Cell_2",w0,h0+hSS,'587-3','602-4',None,None],                  # Type & Velocity
        ["Cell_2",w0,h0+hSS+hC1,'595-4','595-6',None],                   # Track & drive
        ["Cell_1b",w0,h0+hSS+2*hC1,'587-6',None,None],                   # Freq
        ["Cell_3",w0,h0+hSS+2*hC1+hC1b,'588-5','589-5','590-5'],         # Morph 
        ["Cell_1",w0,h0+hSS+3*hC1+hC1b,'591-5',None,None],               # Res/Freq HP
        ["Cell_3",w0,h0+hSS+4*hC1+hC1b,'592-4','593-4','594-4'],         # Morph 

        ["Cell_1b",w0,h0+hSS+5*hC1+hC1b,'595-8',None,None],              # Env Amt
        ["Cell_3",w0,h0+hSS+5*hC1+2*hC1b,'596-7','597-7','598-7'],       # Morph
        ["Cell_3",w0,h0+hSS+6*hC1+2*hC1b,'599-7','600-6','601-5'],       # ADR
     
    ])
    w0 = 3*wPad+600
    h0 = hPad+hSS+5*hC1
    Cells.extend( [
        ["SubSection1",w0,h0,"VOICE",None,None],                         # Voice
        ["Cell_3",w0,h0+hSS,'416-7','416-6','416-8'],                    # Mono & legato & priority
        ["Cell_1b",w0,h0+hSS+hC3,'417-2',None,None],                     # Glide
    ])
    w0 = 3*wPad+600
    h0 = 2*hPad+2*hSS+6*hC1+hC1b
    Cells.extend( [
        ["SubSection1",w0,h0,"VIBRATO",None,None],                       # Vibrato
        ["Cell_1b",w0,h0+hSS,'416-1',None,None],                         # Mode
        ["Cell_3",w0,h0+hSS+hC1b,'602-6','603-5','453-5'],               # Delay, rate & amount
    ])
    w0 = 3*wPad+600
    h0 = 3*hPad+3*hSS+7*hC1+2*hC1b
    Cells.extend( [
        ["SubSection1",w0,h0,"AMP",None,None],                           # Amp
        ["Cell_3",w0,h0+hSS,'584-4','585-3','586-2'],                    # ADR
        ["Cell_1b",w0,h0+hSS+hC3,'587-1',None,None],                     # Velocity
    ])
    w0 = 3*wPad+600
    h0 = 4*hPad+4*hSS+8*hC1+3*hC1b
    Cells.extend( [
        ["SubSection1",w0,h0,"UNISON",None,None],                        # Unison
        ["Cell_1b",w0,h0+hSS,'445-3',None,None]                          # level
    ] )

    for sublist in Cells:
        DispCells(sublist)
        
# ======================================================
#        
#   MAIN GUI program
#
# ======================================================

def showGUI( inputFilename, paramdataTmp, groupparams ):
    global paramdata   # (Randy2) made paramdata global
    global pan1, Win_bg
    global layer
   
    paramdata = paramdataTmp   # (Randy2) made paramdata global

    if 0:
        # (Randy) optional output file for testing
        writeData( inputFilename, groupparams, 'dataForGUI.txt' ) 

    if 0:
        # (Randy) 
        # This writes the list of all parameter IDs, organized and ordered.
        # I used this to help produce the guinames structure at the top of this file.
        writeIDs( groupparams, 'listOfIDs.txt' ) # (Randy2) made paramdata global

    fileType = inputFilename.strip()[-4:]    

    # create main window
     
    root = Tk()
    root.title("ns4decode viewer (version " + ns4maps.version + "), " + inputFilename)
    root.geometry("1480x850") # 1450x800 should be enough on Windows but not on MacOS 
    
    # create a notebook
    
    notebook = ttk.Notebook(root)
    notebook.pack(expand=True, fill='both')
     
    # create the pages
     

    if fileType in ['ns4p', 'ns4l']:
        pag_global = Frame(notebook)
    if fileType in ['ns4p', 'ns4l', 'ns4o']:
        pag_organA = Frame(notebook)
        pag_organB = Frame(notebook)
    if fileType in ['ns4p', 'ns4l', 'ns4n']:
        pag_pianoA = Frame(notebook)
        pag_pianoB = Frame(notebook)
    if fileType in ['ns4p', 'ns4l', 'ns4y']:
        pag_synthA = Frame(notebook)
        pag_synthB = Frame(notebook)
        pag_synthC = Frame(notebook)

    # fill in the pages
    

    if fileType in ['ns4p', 'ns4l']:
        layer=0
        GLOBALpan(pag_global,"GLOBAL")

    if fileType in ['ns4p', 'ns4l', 'ns4o']:
        layer=0
        ORGANpan(pag_organA,"ORGAN A")    
        FXpan(pag_organA,'o')

        layer=1               
        ORGANpan(pag_organB,"ORGAN B")    
        FXpan(pag_organB,'o')
    
    if fileType in ['ns4p', 'ns4l', 'ns4n']:
        layer=0
        PIANOpan(pag_pianoA,"PIANO A")        
        FXpan(pag_pianoA,'p') 
    
        layer=1
        PIANOpan(pag_pianoB,"PIANO B")
        FXpan(pag_pianoB,'p') 

    if fileType in ['ns4p', 'ns4l', 'ns4y']:
        layer=0
        SYNTHpan(pag_synthA,"SYNTH A")        
        FXpan(pag_synthA,'y')  
    
        layer=1
        SYNTHpan(pag_synthB,"SYNTH B")        
        FXpan(pag_synthB,'y')  
    
        layer=2
        SYNTHpan(pag_synthC,"SYNTH C")        
        FXpan(pag_synthC,'y')  


    # add pages to notebook with tab title
    
    if fileType in ['ns4p', 'ns4l']:
        notebook.add(pag_global,text="Global")
    if fileType in ['ns4p', 'ns4l', 'ns4o']:
        notebook.add(pag_organA,text="OrganA")
        notebook.add(pag_organB,text="OrganB")
    if fileType in ['ns4p', 'ns4l', 'ns4n']:
        notebook.add(pag_pianoA,text="PianoA")
        notebook.add(pag_pianoB,text="PianoB")
    if fileType in ['ns4p', 'ns4l', 'ns4y']:
        notebook.add(pag_synthA,text="SynthA")
        notebook.add(pag_synthB,text="SynthB")
        notebook.add(pag_synthC,text="SynthC")

    
    root.mainloop()
