#
#  -------------------------------------------------------------------------
#  MIT License
#  
#  Copyright (c) 2024 Randy
#  
#  Permission is hereby granted, free of charge, to any person obtaining a copy
#  of this software and associated documentation files (the "Software"), to deal
#  in the Software without restriction, including without limitation the rights
#  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
#  copies of the Software, and to permit persons to whom the Software is
#  furnished to do so, subject to the following conditions:
#  
#  The above copyright notice and this permission notice shall be included in all
#  copies or substantial portions of the Software.
#  
#  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
#  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
#  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
#  SOFTWARE.
#  -------------------------------------------------------------------------
#
import ns4maps
import ns4names

execname = 'ns4decode'

# ================================================================
def showIntro():

    print( '' )
    print( 'This is version', ns4maps.version, 'of', execname + ', a utility that', \
            'reads Program files and Preset files from the Nord Stage 4 digital keyboard', \
            'and writes some of the content in human-readable form.', \
            'To list the available options, run the command' )
    print( '' )
    print( '    ', execname, ' --help' )
    print( '' )
    print( 'For instructions, download the User Manual from https://ns4decode.netlify.app/' )

# ================================================================
def showHelp():

    print( '' )
    print( 'Options when decoding' )
    print( '    --gui' )
    print( '        Abbreviation: -g' )
    print( '    --nogui' )
    print( '    --csv' )
    print( '    --nocsv' )
    print( '    --writeto (folder)' )
    print( '        Abbreviation: -w' )
    print( '    --columnwidth (number of characters)' )
    print( '        Abbreviation: -c' )
    print( '    --file (filename)' )
    print( '        Abbreviation: -f' )
    print( '    --find (list of file types separated by commas without spaces)' )
    print( '    --exclude' )
    print( '        Abbreviation: -x' )
    print( '    --includeall (on or off)' )
    print( '        (setting this to off is equivalent to the option -x)' )
    print( '    --askfirst (on or off)' )
    print( '    --warnversion (on or off)' )
    print( '    --verbosity (0, 1, 2, or 3)' )
    print( '        Abbreviation: -v' )
    print( '    --rawdecimal' )
    print( '    --rawhex' )
    print( '    --rawbinary' )
    print( '    --use (folder)' )
    print( '' )
    print( 'Options when not decoding' )
    print( '    --help' )
    print( '        Abbreviation: -h' )
    print( '    --settings' )
    print( '    --listparams' )
    print( '    --listparamsnocodes' )
    print( '    --version' )
    print( '    --bitmaps' )
    print( '' )
    print( 'For instructions, download the User Manual from https://ns4decode.netlify.app/' )

# ================================================================
def showVersion():

    print( 'This is', execname, 'version', ns4maps.version )
